/* write.h : structures used in Write file format */

#pragma pack(1)

/* WRITEFILEHEADER used to write .wri header */
typedef struct tagWRITEFILEHEADER
	{
	WORD		wIndent ;
	WORD		dty ;
	WORD		wTool ;
	WORD		wReserved[4] ;
	DWORD	fcMac ;
	WORD		pnPara ;
	WORD		pnFntb ;
	WORD		pnSep ;
	WORD		pnSetb ;
	WORD		pnPgtb ;
	WORD		pnFfntb ;
	WORD		szSsht[33] ;
	WORD		pnMac ;
	WORD		wReserved2[15] ;
	} WRITEFILEHEADER, FAR* LPWRITEHEADER ;

/* FFN font face names */
typedef struct tagFNN
	{
	WORD		cbFfn ;
	BYTE		ffid ;
	BYTE		szFfn[1] ;
	} FFN, FAR* LPFFN ;

/* FOD format descriptors */
typedef struct tagFOD
	{
	DWORD	fcLim ;
	WORD		bfprop ;
	} FOD, FAR* LPFOD ;

/* TDB tab descriptor table */
typedef struct tagTDB
	{
	WORD		dxa ;
	BYTE		jcTab ;
	BYTE		chAlign ;
	} TDB, FAR* LPTDB ;

/* PAP paragraph property */
typedef struct tagPAP
	{
	BYTE		byReserved ;
	BYTE		jc ;
	BYTE		byReserved2[2] ;
	WORD		dxaRight ;
	WORD		dxaLeft ;
	WORD		dxaLeft1 ;
	WORD		dyaLine ;
	WORD		dyaBefore ;
	WORD		dyaAfter ;
	BYTE		rhc ;
	BYTE		byReserved3[5] ;
	TDB		tdb[14] ;
	} PAP, FAR* LPPAP ;

/* CHP character property */
typedef struct tagCHP
	{
	BYTE		byReserved ;
	BYTE		fFormat ;
	BYTE		hps ;
	BYTE		byReserved2[2] ;
	BYTE		hpsPos ;
	} CHP, FAR* LPCHP ;

/* INFOPAGE character or paragraph information page */
typedef struct INFOPAGE
	{
	DWORD	fcFirst ;
	BYTE		byInfo[123] ;
	BYTE		cfod ;
	} INFOPAGE, FAR* LPINFOPAGE ;

/* SEP section property */
typedef struct tagSEP
	{
	BYTE		cch ;
	WORD		wReserved ;
	WORD		yaMac ;
	WORD		xaMac ;
	WORD		wReserved2 ;
	WORD		yaTop ;
	WORD		dyaText ;
	WORD		xaLeft ;
	WORD		dxaText ;
	} SEP, FAR* LPSEP ;

/* SED structure */
typedef struct tagSED
	{
	DWORD	cp ;
	WORD		fn ;
	DWORD	fcSep ;
	} SED, FAR* LPSED ;

/* SETB section page */
typedef struct tagSETB
	{
	WORD		csed ;
	WORD		csedMax ;
	SED		sed[2] ;
	BYTE		byReserved[104] ;
	} SETB, FAR* LPSETB ;

/* PICTURE structure for pictures in the text stream */
typedef struct tagPICTURE
	{
	METAFILEPICT	mfp ;
	WORD			dxaOffset ;
	WORD			dxaSize ;
	WORD			dyaSize ;
	WORD			cbOldSize ;
	BITMAP		bm ;
	WORD			cbHeader ;
	DWORD		cbSize ;
	WORD			mx ;
	WORD			my ;
	} PICTURE, FAR* LPPICTURE ;

#pragma pack()
